# This is my apple keyboard config

![](https://github.com/Rougemoot/kmonad/blob/master/keymap/user/Rougemoot/image.png)
It is nice.

I use it on my Macbook Pro (2014) as well as my hackintosh (on an older wireless Apple keyboard). Both on macOS.

## What does it do?

### The simple stuff (remaps)

First things first, I *need* my `backspace` key right next to the spacebar (try it, I swear), so the right `command` key is straight up remapped as `backspace`.

Next, the `capslock` key is remapped as `esc` if pressed alone, `fn` if pressed with anything else. This lets me use [skhd](https://github.com/koekeishiya/skhd) to [map various things with `fn`](https://github.com/Rougemoot/dotfiles/blob/master/skhd/skhdrc#L8) to manipulate windows, space, or do other things with my window manager, [yabai](https://github.com/koekeishiya/yabai/).

The tab key is also "tap-hold" mapped as `meh` (that is, ctrl-alt-shift) which lets me use skhd again to continue using `hjkl` to manipulate some stuff in apps like [change servers/channels in Discord](https://github.com/Rougemoot/dotfiles/blob/master/skhd/skhdrc#L129), for example).

Then I tap-hold-mapped the `a` and `;` keys as `shift` so I don't have to move my pinkies for caps. This works very well but I might have to finagle with the timings (or get used to typing "the right way" with it) in the future.

### The a-bit-less-simple stuff (layers)

The idea with this config was to replicate the behaviour of my 40% keyboard on my laptop soa s not to be lost when I go from one to the other. Having no `raise` and `lower` key on the Macbook, and with the inability to chop the spacebar into five equal parts (big sigh) the next best thing was to map `c` and `m` (which are right next to my thumbs) as `lower` and `raise` respectively. This needed some trial-and-error to get right with the tap-hold delays but I feel like I'm close. Once again I'm not sure if I need to adjust the timings or if I just need to get used to typing just right.

**Accents and number row**

Being a frenchman typing on a qwerty keyboard I did need access to all frequently-used accented letters in French, so these are on the raise and lower layers. The whole numbers row is moved to the home row, with numbers on the `lower` layer and symbols on the `raise` layer.

If you look closely at the config you'll see I also added a `shift-raise` and a `shift-lower` layer, those were the only way I could have capitalised accented letters in a sensible way. Note that `Ê` has a whole layer just for himself. lucky bastard. I don't think it'll get much usage, either, but you never know.

**Arrow keys**

Finally, there's the `space` layer on the spacebar (with of course the same tap-hold behaviour as the `c`, `m`, `a` and `;`) which for now is only used to have the arrow keys right under my fingers on `hjkl`, because I've recently started using vim and there *are* some habits that come *very* quickly. This lets me use the spacebar arrow keys in conjuction with my free left hand to hold `command`, `alt` or `shift` to move to the beginning/end of a line, move by word and/or select stuff.

### The... forbidden key?

Yes. [It is forbidden.](https://github.com/kmonad/kmonad/issues/106)

### Wrap-up

I tried to be as tidy as I could in the config, so anyone can understand what I did. I think there are some examples in there for a couple use cases so you can probably find a bit of everything, just in case the kmonad tutorial didn't do it for you.

There are sections, which are foldable (use vim), and a couple comment for the non-obvious stuff. But if you've read everything until here you pretty much know everything already.

Have fun!
